#include <osgDB/ReadFile>
#include <osgViewer/Viewer>
#include <osg/PositionAttitudeTransform>

static float rot = 0.0f;
osg::PositionAttitudeTransform *pat;

class myRotationCallback : public osg::NodeCallback 
{
public:
  virtual void operator()(osg::Node* node, osg::NodeVisitor* nv)
  {
    osg::ref_ptr<osg::PositionAttitudeTransform> pa = (osg::PositionAttitudeTransform *) node;
    rot += 2.0;
    //pat->setAttitude (osg::Quat(osg::DegreesToRadians(90.0), osg::Vec3(1,0,0) ,  osg::DegreesToRadians(0.0), osg::Vec3(0,1,0),  osg::DegreesToRadians(rot), osg::Vec3(0,0,1)  )); 
    pat->setAttitude (osg::Quat(osg::DegreesToRadians(rot), osg::Vec3(1,0,0) ,  osg::DegreesToRadians(0.0), osg::Vec3(0,1,0),  osg::DegreesToRadians(rot), osg::Vec3(0,0,1)  )); 
	traverse(node, nv); 
  }
};
int main(int argc, char **argv)
{
    osg::ref_ptr<osg::Node>  model;
    osgViewer::Viewer viewer;
	pat = new osg::PositionAttitudeTransform;

    model = osgDB::readNodeFile(argv[1]);
    pat->addChild (model);
    osg::Group *root = new osg::Group;
    root->addChild (pat);
	viewer.setSceneData (root);
	pat->setUpdateCallback (new myRotationCallback);
    //viewer.setSceneData(osgDB::readNodeFile(argv[1]));

    return viewer.run();
}

